//----------------------------------------------------------------------------------------
// MSkeleton.cp
// Copyright 1991-1992 Apple Computer, Inc.
//----------------------------------------------------------------------------------------

#ifndef __UPRINTING__
#include <UPrinting.h>
#endif

#ifndef __UAPPLICATIONJAVELIN__
#include "UApplicationJavelin.h"
#endif

#ifndef __UDOCUMENTJAVELIN__
#include "UDocumentJavelin.h"
#endif

#ifndef __UJAVELINVIEW__
#include "UJavelinView.h"
#endif

#ifndef __U3DDRAWING__
#include "U3DDrawing.h"
#endif

// Generate universal code
#pragma processor 68000

//----------------------------------------------------------------------------------------
// main: 
//----------------------------------------------------------------------------------------
#pragma segment Main
void main ()
{
//	TApplicationJavelin	*gApplicationJavelin;			// Application object
	
	InitToolBox();											// Essential toolbox & utilities
	
	if (ValidateConfiguration(gConfiguration))
	{
		InitUMacApp(8);										// Initialize MacApp with 10 calls to MoreMasters
		InitUPrinting();									// Initialize the printing gear
		InitUTEView();										// Initialize the text editing unit 
		InitUDialog();										// Initialize the dialog unit
		InitU3DDrawing();									// Initialize the 3D stuff unit
		
		InitUJavelinView();								// Initialize the application's view unit.

		gApplicationJavelin = new TApplicationJavelin;	// Allocate application object
		gApplicationJavelin->IApplicationJavelin();		//	Initialize the object
		gApplicationJavelin->Run();						//	Well lets run it then!
	}
	else
		StdAlert(phUnsupportedConfiguration);
} // main 

