//----------------------------------------------------------------------------------------
// UCommandJavelin.cp
// Copyright 1991-1992 Apple Computer, Inc.
//----------------------------------------------------------------------------------------

#ifndef __UCOMMANDJAVELIN__
#include "UCommandJavelin.h"
#endif

#ifndef __UAPPLICATIONJAVELIN__
#include "UApplicationJavelin.h"
#endif

#ifndef __UDOCUMENTJAVELIN__
#include "UDocumentJavelin.h"
#endif

#ifndef __UJAVELINVIEW__
#include "UJavelinView.h"
#endif

#ifndef __ERRORS__
#include <Errors.h>
#endif

#ifndef __UREMOTECOMMANDS__
#include "URemoteCommands.h"
#endif

#ifndef __PPCTOOLBOX__
#include <PPCToolbox.h>
#endif

// *********************************  Constants  ************************************* //  all new rD

const short  ppcInternetLocation 	= 3;
TApplicationJavelin* gApplicationJavelin;

// *********************************  Utilities  ************************************* //

//--------------------------------------------------------------------------------------------------

/*
 *	MyPPCBrowserFilter
 *
 *	Thanks to Eric Berhdahl & Eric Soldan and his Kibitz application for the tips
 *	on how to implement this funciton.
 */
 
#pragma segment ADoCommand
static pascal Boolean MyPPCBrowserFilter(LocationNamePtr /* theLocation */, PortInfoPtr thePortInfo)
{
	OSType	type;

	if (thePortInfo->name.portKindSelector == ppcByString)
	{
		BlockMove(thePortInfo->name.u.portTypeStr + 1, Ptr(&type), sizeof(type));
			// The BlockMove is so that we don't get an address error
			// on a 68000-based machine due to referencing a long at
			// an odd-address.
		if (type == kSignature)
			return TRUE;
	}
	return FALSE;
}

// *********************************  TLookupLauncher  ************************************* //

//--------------------------------------------------------------------------------------------------
#pragma segment ADoCommand
pascal void TLookupLauncher::DoIt()	// OVERRIDE
{
	// This command runs the PPCBrowser dialog. If not canceled by the user,
	// it opens the modeless Lookup dialog.
	
	PortInfoRec		thePortInfo;
	TargetID		theTargetID;
	OSErr theErr;
	CStr255 		windowTitle;
	FailInfo fi;

	// use PPCBrowser to locate the schedule to use.
		theErr = PPCBrowser("\pSelect a Unix Server.", "\pServers",
							 FALSE /* defaultSpecified */, theTargetID.location, thePortInfo,
							 MyPPCBrowserFilter, "\pUNIX PPCToolbox");
		if (theErr == noErr)
		{
		}
		else if (theErr != userCanceledErr)
			FailOSErr(theErr);
		else
			return;

	// get the AE Address
	theTargetID.name = thePortInfo.name;

		switch (theTargetID.location.locationKindSelector)
	{
		case ppcNoLocation:						// my own machine
			fDocument->SetAddress(theTargetID);
			fDocument->SetPortRefNum(gNumUntitled);
			fDocument->SetfWindowTitle(CStr255("This is a local node"));

			break;
		case ppcNBPLocation:					// we are handling this case
			fDocument->SetAddress(theTargetID);
			fDocument->SetPortRefNum(gNumUntitled);
			BlockMove(&theTargetID.location.u.nbpEntity.objStr, &windowTitle, 33);
			fDocument->SetfWindowTitle(windowTitle);
			break;
		default:
			DebugStr("\p Help me Rhonda.  If you can read this you're too close.");
	}
	
	// lets check the version number
	
		InvalidateMenus();    //global routine... not sure who the target is in this case.  we'll see.
		this->WakeupServer();


if  (fDocument->Connected())
			this->CheckVersion();

	//	Words of wisdom, the nbpEntity record is trash if the PPC selection is on the same
	//	local node. It is very important to check the locationKindSelector (as above) and
	//	only use the npbEntity record when we have a ppcNBPLocation!!! See IM VI-7 for more
	//	information about this (it's well hidden!)
}


//--------------------------------------------------------------------------------------------------
#pragma segment ASelCommand
pascal void TLookupLauncher::ILookupLauncher(CommandNumber aCommandNumber,
										   TDocumentJavelin* theDoc)
{
	this->ICommand(aCommandNumber, NULL, kCantUndo, kDoesNotCauseChange, NULL);  //rD was
	fDocument = theDoc;
}

//--------------------------------------------------------------------------------------------------
#pragma segment ASelCommand
pascal void TLookupLauncher::WakeupServer()
{
		TWakeupCommand* aCommand = new TWakeupCommand;
		aCommand->IWakeupCommand(fDocument);
		fDocument->PostCommand(aCommand);
}
//--------------------------------------------------------------------------------------------------
#pragma segment ASelCommand
pascal void TLookupLauncher::CheckVersion()
{
		TJavelinVersionCmd* aCommand = new TJavelinVersionCmd;
		aCommand->IJavelinVersionCmd(this->fDocument);
		fDocument->PostCommand(aCommand);
}


//--------------------------------------------------------------------------------------------------
#pragma segment AEvent
pascal void TConfigCommand::DoIt()	// Override
{
//	long 		actualSize;
	
	AppleEvent	theEvent = fMessage->fMessage;
	CStr255 errorMsg, aString;
	
	TDocumentJavelin* itsDoc = (TDocumentJavelin*)fContext;	
	
	itsDoc->CommandCompleted();
	
}

