/*
	UDocumentJavelin.h
	
	Copyright 1991-1992 Apple Computer, Inc.
 	All rights reserved

	Change History:
	
 */

#ifndef __UDOCUMENTJAVELIN__
#define __UDOCUMENTJAVELIN__

class PascalObj TJavelinView;
class PascalObj TApplicationJavelin;

extern char*	gJavelinVersion = "00.00";
extern TApplicationJavelin* gApplicationJavelin;
//----------------------------------------------------------------------------------------
// Constants:
const ResNumber	kCmdAEEvents =			1001;		// 'aedt' resource constant
const ResNumber	kAlertUserToError =		1001;		// error string rsrc ID
const OSType	kAECmdSuiteID = 		'A/UX';		// AE class
const OSType 	kAEunixType = 			'unix';
const long 	BUFSIZ	= 				10000;

const short	kJavelinWindowID = 		5500;     //ice pick  DiscusIcePick.rsrc
const short	kConfirmBox =			5996;
const short	kInfoBox =				5997;
const short	kErrorBox =				5998;
//const short	kStatusBox = 			5999;

extern pascal void JavelinErrorBox(CStr255& theMessage, const CStr255& param1=gEmptyString, const CStr255& param2=gEmptyString, const CStr255& param3=gEmptyString);
extern pascal void JavelinErrorBoxNumber(int theErrorNum, const CStr255& param1=gEmptyString, const CStr255& param2=gEmptyString, const CStr255& param3=gEmptyString);
extern pascal void JavelinInfoBox(CStr255& theMessage, const CStr255& param1=gEmptyString, const CStr255& param2=gEmptyString, const CStr255& param3=gEmptyString);
extern pascal void JavelinInfoBoxNumber(int theErrorNum, const CStr255& param1=gEmptyString, const CStr255& param2=gEmptyString, const CStr255& param3=gEmptyString);
extern pascal Boolean JavelinConfirmBox(CStr255& theMessage, const CStr255& param1=gEmptyString, const CStr255& param2=gEmptyString, const CStr255& param3=gEmptyString);
extern pascal Boolean JavelinConfirmBoxNumber(int theErrorNum, const CStr255& param1=gEmptyString, const CStr255& param2=gEmptyString, const CStr255& param3=gEmptyString);
extern pascal void SubstituteDialogText(CStr255& theMessage, const CStr255& param1=gEmptyString, const CStr255& param2=gEmptyString, const CStr255& param3=gEmptyString);

// Error constants for JavelinErrorBox - or whatever
const			kUnknownJavelinError =	3;     //also sent by server
const			kCheckPulseError =		8;
const			kBadVersionError =		9;
const			kNoVersionError = 		10;

// Commands
const OSType kSignature = 'JVLN';			// File-type code used for document files	(also in .r)

//----------------------------------------------------------------------------------------
// TDocumentJavelin
//----------------------------------------------------------------------------------------

class TDocumentJavelin: public TDocument
{
public:
	TJavelinView*			fJavelinView;
	AEAddressDesc			fAEAddressDesc;
	long					fHeartBeatCounter;
	short					fPortRefNum;
	CStr255					fHostVersion;
	short					fInterval;
private:
	Boolean					fCommandOut;
	CStr255 				fWindowTitle;
	
public:		
	// Construction/Destruction
	virtual pascal void 		Initialize(); // Override
	
	virtual pascal void  		IDocumentJavelin();
	virtual pascal void  		Free(); // Override
	virtual pascal void  		Close(); // Override
	virtual pascal void  		Disconnect(); // Override
			
	// Views
	virtual pascal void  		DoMakeViews(Boolean forPrinting); // Override

	// Commands
	virtual pascal void  		DoSetupMenus(); // Override
	virtual pascal void  		DoMenuCommand(CommandNumber aCommandNumber); // Override
	virtual pascal void			DoPostMakeViews(Boolean forPrinting);
	virtual pascal void		 	SetWindowText(CStr255 theText);
	
	//
	virtual pascal void 		GetAEAddressDesc(AEAddressDesc& theAddress);
	virtual pascal void 		SetAddress(TargetID& theTarget);
	virtual pascal void 		SetPortRefNum(short thePortRefNum);
	virtual pascal short 		GetPortRefNum();
	virtual pascal Boolean 		Connected();
	virtual pascal void 		SetHostVersion(CStr255 theVersion);
	virtual pascal void 		HaveAHeartBeat();
	virtual pascal Boolean 		CheckPulse();

	virtual pascal void 		SetTitle(const CStr255& aTitle);	
	virtual pascal void 		SetfWindowTitle(const CStr255& aTitle);	

	virtual pascal void 		PendingCommand();
	virtual pascal void	 		CommandCompleted();
	virtual pascal Boolean		HasPendingCommands();
	
	virtual pascal Boolean	LocateDocument(long theSessionID);	
};

#endif
