// UJavelinDialogs.cp

#ifndef __UJAVELINDIALOGS__
#include "UJavelinDialogs.h"
#endif

#ifndef __UDOCUMENTJAVELIN__
#include "UDocumentJavelin.h"
#endif

#ifndef __AUXAESuite__
#include "AUXAESuite.h"
#endif

#ifndef TOOLUTILS
#include <ToolUtils.h>
#endif


//----------------------------------------------------------------------------------------
// JavelinErrorBox: 
//----------------------------------------------------------------------------------------
#pragma segment DlgInit
pascal void JavelinErrorBox(CStr255& theMessage, const CStr255& param1 ,
												const CStr255& param2 ,
												const CStr255& param3 )

{
	SubstituteDialogText(theMessage, param1, param2, param3);

	TWindow* theWindow = gViewServer->NewTemplateWindow(kErrorBox, NULL);
	FailNIL(theWindow);
	
	((TStaticText*)theWindow->FindSubView('MSGT'))->SetText(theMessage, TRUE);

	SysBeep(2);
	IDType dismisser = theWindow->PoseModally();
	switch(dismisser) {
		default:
//			theWindow->CloseAndFree();
			TCloseWindowCommand* aCCmd = new TCloseWindowCommand;
			aCCmd->ICloseWindowCommand(cClose, theWindow);
			theWindow->PostCommand(aCCmd);
			break;
	}	
}
//----------------------------------------------------------------------------------------
// JavelinErrorBoxNumber: 
//----------------------------------------------------------------------------------------
#pragma segment DlgInit
pascal void JavelinErrorBoxNumber(int theErrorNum, const CStr255& param1 ,
												const CStr255& param2 ,
												const CStr255& param3 )

{

	CStr255 theString;
	
	GetIndString(theString,kAlertUserToError  /*1001*/, theErrorNum);
	if (theString.IsEmpty())
		GetIndString(theString,kAlertUserToError  /*1001*/, kUnknownJavelinError   /* 3 */);

	JavelinErrorBox(theString, param1, param2, param3);
}
//----------------------------------------------------------------------------------------
// JavelinInfoBoxNumber: 
//----------------------------------------------------------------------------------------
#pragma segment DlgInit
pascal void JavelinInfoBoxNumber(int theErrorNum, const CStr255& param1 ,
												const CStr255& param2 ,
												const CStr255& param3 )

{

	CStr255 theString;
	
	GetIndString(theString,kAlertUserToError  /*1001*/, theErrorNum);
	if (theString.IsEmpty())
		GetIndString(theString,kAlertUserToError  /*1001*/, kUnknownJavelinError   /* 3 */);

	JavelinInfoBox(theString, param1, param2, param3);
}
//----------------------------------------------------------------------------------------
// JavelinInfoBoxNumber: 
//----------------------------------------------------------------------------------------
#pragma segment DlgInit
pascal Boolean JavelinConfirmBoxNumber(int theErrorNum, const CStr255& param1 ,
												const CStr255& param2 ,
												const CStr255& param3 )

{
	CStr255 theString; 
	
	GetIndString(theString,kAlertUserToError  /*1001*/, theErrorNum);
	if (theString.IsEmpty())
		GetIndString(theString,kAlertUserToError  /*1001*/, kUnknownJavelinError   /* 3 */);

	return JavelinConfirmBox(theString, param1, param2, param3);
}
//----------------------------------------------------------------------------------------
// JavelinInfoBox: 
//----------------------------------------------------------------------------------------
#pragma segment DlgInit
pascal void JavelinInfoBox(CStr255& theMessage, const CStr255& param1 ,
												const CStr255& param2 ,
												const CStr255& param3 )

{
	SubstituteDialogText(theMessage, param1, param2, param3);

	TWindow* theWindow = gViewServer->NewTemplateWindow(kInfoBox, NULL);
	FailNIL(theWindow);
	
	((TStaticText*)theWindow->FindSubView('MSGT'))->SetText(theMessage, TRUE);

	SysBeep(2);
	IDType dismisser = theWindow->PoseModally();
	switch(dismisser) {
		default:
//			theWindow->CloseAndFree();
			TCloseWindowCommand* aCCmd = new TCloseWindowCommand;
			aCCmd->ICloseWindowCommand(cClose, theWindow);
			theWindow->PostCommand(aCCmd);
			break;
		}	
}
//----------------------------------------------------------------------------------------
// JavelinConfirmBox: 
//----------------------------------------------------------------------------------------
#pragma segment DlgInit
pascal Boolean JavelinConfirmBox(CStr255& theMessage, const CStr255& param1 ,
												const CStr255& param2 ,
												const CStr255& param3 )

{
	SubstituteDialogText(theMessage, param1, param2, param3);
	
	TWindow* theWindow = gViewServer->NewTemplateWindow(kConfirmBox, NULL);
	FailNIL(theWindow);
	
	((TStaticText*)theWindow->FindSubView('MSGT'))->SetText(theMessage, TRUE);

	SysBeep(2);
	IDType dismisser = theWindow->PoseModally();
//	theWindow->CloseAndFree();
	TCloseWindowCommand* aCCmd = new TCloseWindowCommand;
	aCCmd->ICloseWindowCommand(cClose, theWindow);
	theWindow->PostCommand(aCCmd);
	switch(dismisser) {
		case 'OK  ':
			return TRUE;
		case 'CNCL':
			return FALSE;
		default:
			return FALSE;
	}	


}

//----------------------------------------------------------------------------------------
// SubstituteDialogText: 
//----------------------------------------------------------------------------------------
#pragma segment DlgInit
pascal void SubstituteDialogText(CStr255& theMessage, const CStr255& param1 ,
												const CStr255& param2 ,
												const CStr255& param3 )

{
	const CStr255	kParamText1 = "^0";
	const CStr255	kParamText2 = "^1";
	const CStr255	kParamText3 = "^2";
	short i = theMessage.Pos(kParamText1);
	if (i && !param1.IsEmpty())
		{

		theMessage.Delete(i, kParamText1.Length());
		theMessage.Insert(param1, i);
		}

	i = theMessage.Pos(kParamText2);
	if (i && !param2.IsEmpty())
		{

		theMessage.Delete(i, kParamText2.Length());
		theMessage.Insert(param2, i);
		}
	i = theMessage.Pos(kParamText3);
	if (i && !param3.IsEmpty())
		{

		theMessage.Delete(i, kParamText3.Length());
		theMessage.Insert(param3, i);
		}
}