// URemoteCommands.h
// Copyright 1991-1994 Apple Computer, Inc.

#ifndef __UREMOTECOMMANDS__
#define __UREMOTECOMMANDS__

class PascalObj TAppleEvent;
class PascalObj TJavelinAppleEvent;
class PascalObj TDocumentJavelin;

const long 	cRemoteCommand = 998;


//----------------------------------------------------------------------------------------------
//	TJavelinClientCommand
//----------------------------------------------------------------------------------------------
class TJavelinClientCommand: public TClientCommand
{
protected:
	Boolean 	fPostage;
public:
	virtual pascal void 		IJavelinClientCommand(TDocumentJavelin* itsDocument, 
												const int theKey,
												TObject* toNotify);			// Override
	virtual pascal void 		ProcessReply(TAppleEvent* theReply);		// Override
	virtual pascal TAppleEvent* SendMessage();							// Override	
};
//----------------------------------------------------------------------------------------------
//	kAEVersion
//----------------------------------------------------------------------------------------------
class TJavelinVersionCmd: public TJavelinClientCommand
{
public:
	virtual pascal void	IJavelinVersionCmd(TDocumentJavelin* itsDocument);	// Override
	virtual pascal void 		ProcessReply(TAppleEvent* theReply);
};

//----------------------------------------------------------------------------------------------
//	kAEQuit
//----------------------------------------------------------------------------------------------
class TQuitCmd: public TClientCommand
{
public:
	virtual pascal void	IQuitCmd(TDocumentJavelin* itsDoc);						// Override
};
//----------------------------------------------------------------------------------------------
//	kAEInterval
//----------------------------------------------------------------------------------------------
class TIntervalCmd: public TJavelinClientCommand
{
public:
	virtual pascal void	IIntervalCmd(TDocumentJavelin* itsDoc);						// Override
};
//----------------------------------------------------------------------------------------------
//	kAENull
//----------------------------------------------------------------------------------------------
class TWakeupCommand: public TJavelinClientCommand
{
public:
	virtual pascal void	IWakeupCommand(TDocumentJavelin* itsDoc);
};
//----------------------------------------------------------------------------------------------
//	kAENull   - no reply - no command in progress dialog...
//----------------------------------------------------------------------------------------------
class THeartBeatCommand: public TClientCommand
{
public:
	virtual pascal void	IHeartBeatCommand(TDocumentJavelin* itsDoc);
};


#endif